{* DO NOT EDIT THIS FILE! Use an override template instead. See the overriding documentation below *}

{**
 * Available variables:
 *
 * eZContentObject $content_object The published content object
 * eZContentObjectVersion  $content_object_version The published version
 * eZContentClass $content_class The published object's content class
 *
 * OVERRIDING THIS TEMPLATE
 *
 * When overriding this template, be very careful when it comes to the divs names.
 * The template contains 4 divs that must exist with the same id, class and sub-items:
 *
 * #ezap-error: error messages returned by the queue
 *
 * <div class="ezap-placeholder" id="ezap-message-publishing" />
 *    displayed from the start, while the object is being published
 *
 * <div class="ezap-placeholder" id="ezap-message-finished" />
 *    displayed when the object has been successfully published
 *    child: <a id="ezap-contentview-uri" href="#">
 *        The url_alias for the published node will be assigned to this item's href
 *
 * <div class="ezap-placeholder" id="ezap-message-deferred" style="display: none" />
 *    displayed when the object's publishing has been interrupted and deferred to crontab. This
 *    can happen when an ezapprove workflow is in place, or any other type of workflow event that sends the item to cron
 *    child: <a id="ezap-versionview-uri" href="#">
 *        The content/versionview URI will be assigned to this item's href
 *}

{ezscript_require( array( 'ezjsc::yui3', 'ezjsc::yui3io', 'ezasynchronouspublishing.js' ) )}

<script type="text/javascript">
eZAsynchronousPublishingApp.cfg = {ldelim}
    contentobject_id: {$contentObjectId},
    version: {$version},
    redirect_uri: {if is_set( $redirect_uri )}"{$redirect_uri|wash( 'javascript' )}"{else}false{/if},
    failure_message: "{'A fatal error occured while checking the version status, you can try to refresh this page or contact your administrator.'|i18n( 'design/standard/location' )|wash( 'javascript' )}",
    last_checked_message: "{'(Checking every %ms%ms and checked %times% times so far)'|i18n( 'design/standard/location' )|wash( 'javascript' )}",

{rdelim};
eZAsynchronousPublishingApp.init()
</script>

{* placeholder for error messages from the queue *}
<div id="ezap-error" style="display: none" class="message-error">
</div>

{* placeholder for text shown while the object is being published *}
<div class="ezap-placeholder message-confirmation" id="ezap-message-publishing">
    <h1>{'Your content is being published'|i18n( 'design/standard/content' )}</h1>
    {"Please wait while your content is being published"|i18n('design/standard/location')}
</div>

{* placeholder for text shown when the object has been published *}
<div class="ezap-placeholder message-feedback" id="ezap-message-finished" style="display: none">
    <h1>{'Publishing finished'|i18n( 'design/standard/content' )}</h1>
    {"Your content has been published successfully"|i18n( 'design/standard/location' )}<br />
    <a id="ezap-contentview-uri" href="#">{"View the published item"|i18n('design/standard/location')}</a>
</div>

{* placeholder for text shown when publishing has been deferred to cron (for instance by ezapprove) *}
<div class="ezap-placeholder message-feedback" id="ezap-message-deferred" style="display: none">
    <h1>{'Your content is pending an external action'|i18n( 'design/standard/content' )}</h1>
    {"Publishing has been deferred to crontab and will be published when the operation resumes. The object is also listed in your dashboard under pending items."|i18n( 'design/standard/location' )}
    <a id="ezap-versionview-uri" href="#">{"View your pending content"|i18n( 'design/standard/location' )}</a>
</div>
